<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css" integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N" crossorigin="anonymous">
    <title>Bootstrap - Flex</title>
</head>

<body>

    <div class="text-center">

        <h1 class="mb-1 mt-4 text-danger font-weight-bold">Bootstrap - Flex</h1>
        <p>Used the d-flex class to create a flex container and transform direct children into flex items.</p>


        <h2 class="mb-2">Centering Elements</h2>
        <div style="height: 500px;" class="shadow bg-secondary p-3 d-flex justify-content-center align-items-center flex-column">
            <div class="h-25 p-3 bg-success">Flex Item A</div>
            <div class="h-25 p-3 bg-warning">Flex Item B</div>
            <div class="h-25 p-3 bg-danger">Flex Item C</div>
        </div>
        <h2 class="mt-4">Flex Row</h2>
        <div class="bg-dark p-3 d-flex align-items-center flex-row">
            <div class="p-3 bg-success">Flex Item A</div>
            <div class="p-3 bg-warning">Flex Item B</div>
            <div class="p-3 bg-danger">Flex Item C</div>
        </div>

        <h2 class="mt-4">Flex Row Reverse</h2>
        <div class="bg-dark p-3 d-flex align-items-center flex-row-reverse">
            <div class="p-3 bg-success">Flex Item A</div>
            <div class="p-3 bg-warning">Flex Item B</div>
            <div class="p-3 bg-danger">Flex Item C</div>
        </div>

        <h2 class="mt-4">Creating Space Between Elements</h2>
        <div class="bg-dark p-3 d-md-flex justify-content-around">
            <div class="p-3 bg-success col-md-2">Flex Item A</div>
            <div class="p-3 bg-warning col-md-2">Flex Item B</div>
            <div class="p-3 bg-danger col-md-2">Flex Item C</div>
        </div>

        <!-- usually for nav, push element to right then others to left -->
        <h2 class="mt-4">Flexbox With Margin</h2>
        <div class="bg-dark p-3 d-flex ">
            <div class="p-3 bg-success mr-auto">Flex Item A</div>
            <div class="p-3 bg-warning ">Flex Item B</div>
            <div class="p-3 bg-danger ">Flex Item C</div>
            <div class="p-3 bg-primary ">Flex Item D</div>
        </div>

        <h2 class="mt-4">Nested Flex Elements</h2>
        <div class="bg-dark p-3 d-block d-md-flex">
            <div class="p-3 bg-success mr-auto">Flex Item A</div>
            <div class="w-50 d-block d-md-flex justify-content-between">
                <div class="p-3 bg-warning">Flex Item B</div>
                <div class="p-3 bg-danger">Flex Item C</div>
                <div class="p-3 bg-primary">Flex Item D</div>
            </div>
        </div>

    </div>

    <script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-Fy6S3B9q64WdZWQUiU+q4/2Lc9npb8tCaSX9FK7E8HnRr0Jz8D6OP9dO5Vg3Q9ct" crossorigin="anonymous"></script>
</body>

</html>